# API Documentation

## 影院影厅信息、放映服务器权限获取（ 本地 ）

| key | detail |
|---|---|
| code | 请求是否成功编码：100为成功 |
| message | 错误信息提示 |
| result.code | 影院专资ID |
| result.ftp | For Dolby |
| result.auditList[] | 影厅配置列表配置 |


### result.auditList[]

| key | detail |
|---|---|
| serverLoginUser | 服务器登录用户名 |
| serverType | 服务器类型 |
| serverLoginPassword | 服务器登录密码 |
| serverIp | 服务器ip地址 |
| auditNumber | 影厅号 |

### result.ftp

| key | detail |
|---|---|
| ftpIP | ftpIP地址 |
| ftpUserName | ftp登录用户名 |
| ftpPassword | ftp登录密码 |
| rootPath | 路径 |

```
{
  "code"   : 100,
  "message": "",
  "result" : {
    "code"     : "20901928489284",
    "auditList": [
      {
        "serverLoginUser"    : "a",
        "serverType"         : "Sony",
        "serverLoginPassword": "a",
        "serverIp"           : "127.0.0.1",
        "auditNumber"        : 1
      },
      
      ...
      
    ],
    "ftp"      : {
      "ftpIP"      : "127.0.0.1",
      "ftpUserName": "tms",
      "ftpPassword": "tms",
      "rootPath"   : "kdm"
    }
  }
}
```

## 播放状态问询 ( 本地 )

| key | detail |
|---|---|
| code | 请求是否成功编码：100为成功 |
| message | 错误信息提示 |
| result | 影厅放映状态 |

### result[]

| key | detail |
|---|---|
| auditNumber | 影厅编号 |
| status | 是否可以抓取日志：true:是; false:否 |

```
{
  "code"   : 100,
  "message": "",
  "result" : [
    {
      "auditNumber": 1,
      "status"     : true
    },
    
    ...
    
  ]
}
```

## 数据上报 ( 秒针收数接口 )

影院 + 厅 + 日期 + 内容，也可将数据进行本地缓存，待收集完毕后一并上报，规则视接口要求而定

| key | detail |
|---|---|
| cinemaCode | 影院专资ID |
| audit | 影厅 |
| date | 日期 |
| content | 日志内容 |

```
{
  "cinemaCode": "20901928489284",
  "audit"     : "1",
  "date"      : "2019-09-15",
  "content"   : "<?xml version=\"1.0\" ... LogReport>"
}
```
