#!/usr/bin/env bash

echo "\
===================================================
 MiaozhenProbe Installation
===================================================
"

PACKAGE_PATH="/home/Miaozhen"
PACKAGE_NAME="MiaozhenProbe"
SERVICE_NAME="MiaozhenProbeService"

PACKAGE_URL="http://axis-config.oss-cn-beijing.aliyuncs.com/MiaozhenProbe/MiaozhenProbe.jar"

# Create working path
echo "Create working path ${PACKAGE_PATH}"

mkdir -p ${PACKAGE_PATH}
pushd ${PACKAGE_PATH}

# Download
echo "Downloading [ MiaozhenProbe.jar ] from [ ${PACKAGE_URL} ] ..."
wget -q ${PACKAGE_URL} -O ./${PACKAGE_NAME}.jar
echo "Download ... successed!"
chmod og+x ${PACKAGE_NAME}.jar

# Add to system service and auto startup
chkconfig ${SERVICE_NAME} off
chkconfig --del ${SERVICE_NAME}
rm -f /etc/init.d/${SERVICE_NAME}

echo "Register to system service ... successed!"
ln -s /home/Miaozhen/${PACKAGE_NAME}.jar /etc/init.d/${SERVICE_NAME}
chkconfig --add ${SERVICE_NAME}
chkconfig ${SERVICE_NAME} on
echo "Register to auto start ... successed!"

# startup
echo "Start service ... successed!"
service ${SERVICE_NAME} restart

echo "Done!"

popd