package com.miaozhen;

import com.miaozhen.util.FileUtil;
import com.miaozhen.util.FileUtils;
import com.miaozhen.util.Version;
import org.apache.commons.codec.digest.DigestUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.system.ApplicationHome;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URISyntaxException;

/**
 * 程序入口类
 */
@SpringBootApplication
@ServletComponentScan
@ComponentScan
//开启异步调用方法
@EnableAsync(proxyTargetClass = true)
@EnableScheduling
@EnableCaching
public class Application {

    private final static Logger log = LoggerFactory.getLogger(Application.class);

    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);
        log.info("------------------MiaozhenProbe is running!-----------------------");
        log.info("MiaozhenProbe version is:{},versionDate is:{}", Version.version(),Version.versionDate());
        System.out.println("Public network=" + FileUtils.getIp());
        System.out.println("getCinemaInfoMd5="+FileUtil.getCinemaInfoMd5());
    }
}

