package com.miaozhen.device.common;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

public class Printable {

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		Field[] fields = getClass().getDeclaredFields();
		Field.setAccessible(fields, true);
		builder.append('[');
		for (Field field : fields) {
			if (Modifier.isStatic(field.getModifiers()))
				continue;
			builder.append(", ");
			builder.append(field.getName());
			builder.append(" = ");
			try {
				builder.append(field.get(this));
			} catch (IllegalArgumentException | IllegalAccessException e) {
				builder.append(e.toString());
			}
		}
		builder.delete(1, 3);
		builder.append(']');
		return super.toString() + builder.toString();
	}

}
