/**
 * StringResponse.java
 * @author Kamil
 * Created at 2013年11月30日
 */
package com.miaozhen.device.response;

/**
 * String Response.
 * 
 * @author Kamil
 * 
 */
public class StringResponse extends Response {

	protected String response;

	public StringResponse(String string) throws Exception {
		this(string, "response_text");
	}

	public StringResponse(final String string, final String tagName) throws Exception {
		super(string);
		
		String startTag = "<" + tagName + ">";
		String endTag = "</" + tagName + ">";
		
		try {
			if (status() != OK)
				return;
			int start = string.indexOf(startTag);
			int end = string.indexOf(endTag);
			response = string.substring(start + startTag.length(), end);
		} catch (Exception e) {
			//logger.error(e.toString());
			throw new Exception(e);
		} finally {
			handler = null;
			parser = null;
		}
	}

	public String getResponse() {
		return response;
	}
}
