/**
 * PlaybackStatus.java
 * @author Kamil
 * Created at 2013年11月28日
 */
package com.miaozhen.device.smi;


import com.miaozhen.device.common.Printable;
import com.miaozhen.device.model.CPLInfo;
import com.miaozhen.device.model.Schedule;

import java.util.List;

/**
 * A play back status wrapper.
 * 
 * @author lzj
 * 2016年2月29日
 * PlaybackStatus.java
 */
public class PlaybackStatus extends Printable {
    public static final int PLAYBACKMODE_ERROR = -1;

    public static final int PLAYBACKMODE_2D = 2;

    public static final int PLAYBACKMODE_3D = 3;

    public static final int PLAYBACKMODE_DOLBY3D = 4;

    public static final int STATE_DISCONNECTED = -2;

    public static final int STATE_ERROR = -1;

    public static final int STATE_STOPPED = 0;

    public static final int STATE_PLAYING = 1;

    public static final int STATE_PAUSED = 2;

    public static final int STATE_READY = 3;

    public static final int STATE_WAITINGFORLOADING = 4;

    public static  final  int Manual = 0;

    public static  final  int Scheduled =1;

    private String playType;

    private int playbackMode;//0:手动 Manual 1：自动 Scheduled

    private int state;

    private String showUUID;

    private String showName;

    private int showPosition, showDuration;

    private String cplUUID;

    private String cplName;

    private int cplIndex;

    private int cplPostion, cplDuration;

    private List<CPLInfo> cplInfoList;

    private Schedule nextSchedule;

    public String getPlayType() {
        return playType;
    }

    public void setPlayType(String playType) {
        this.playType = playType;
    }

    /**
     * @return the playbackMode
     */
    public int getPlaybackMode() {
        return playbackMode;
    }

    /**
     * @param playbackMode
     * the playbackMode to set
     */
    public void setPlaybackMode(int playbackMode) {
        this.playbackMode = playbackMode;
    }

    /**
     * @return the state
     */
    public int getState() {
        return state;
    }

    /**
     * @param state
     * the state to set
     */
    public void setState(int state) {
        this.state = state;
    }

    /**
     * @return the showUUID
     */
    public String getShowUUID() {
        return showUUID;
    }

    /**
     * @param showUUID
     * the showUUID to set
     */
    public void setShowUUID(String showUUID) {
        this.showUUID = showUUID;
    }

    /**
     * @return the showName
     */
    public String getShowName() {
        return showName;
    }

    /**
     * @param showName
     * the showName to set
     */
    public void setShowName(String showName) {
        this.showName = showName;
    }

    /**
     * @return the showPostion
     */
    public int getShowPosition() {
        return showPosition;
    }

    /**
     * @param showPosition
     * the showPostion to set
     */
    public void setShowPosition(int showPosition) {
        this.showPosition = showPosition;
    }

    /**
     * @return the showDuration
     */
    public int getShowDuration() {
        return showDuration;
    }

    /**
     * @param showDuration
     * the showDuration to set
     */
    public void setShowDuration(int showDuration) {
        this.showDuration = showDuration;
    }

    /**
     * @return the cplUUID
     */
    public String getCPLUUID() {
        return cplUUID;
    }

    /**
     * @param cplUUID
     * the cplUUID to set
     */
    public void setCPLUUID(String cplUUID) {
        this.cplUUID = cplUUID;
    }

    /**
     * @return the cplName
     */
    public String getCPLName() {
        return cplName;
    }

    /**
     * @param cplName
     * the cplName to set
     */
    public void setCPLName(String cplName) {
        this.cplName = cplName;
    }

    /**
     * @return the cplIndex
     */
    public int getCPLIndex() {
        return cplIndex;
    }

    /**
     * @param cplIndex
     * the cplIndex to set
     */
    public void setCPLIndex(int cplIndex) {
        this.cplIndex = cplIndex;
    }

    /**
     * @return the cplPostion
     */
    public int getCPLPostion() {
        return cplPostion;
    }

    /**
     * @param cplPostion
     * the cplPostion to set
     */
    public void setCPLPostion(int cplPostion) {
        this.cplPostion = cplPostion;
    }

    /**
     * @return the cplDuration
     */
    public int getCPLDuration() {
        return cplDuration;
    }

    /**
     * @param cplDuration
     * the cplDuration to set
     */
    public void setCPLDuration(int cplDuration) {
        this.cplDuration = cplDuration;
    }

    public List<CPLInfo> getCplInfoList() {
        return cplInfoList;
    }

    public void setCplInfoList(List<CPLInfo> cplInfoList) {
        this.cplInfoList = cplInfoList;
    }

    public Schedule getNextSchedule() {
        return nextSchedule;
    }

    public static int getScheduled() {
        return Scheduled;
    }

    public void setNextSchedule(Schedule nextSchedule) {
        this.nextSchedule = nextSchedule;
        if(this.nextSchedule != null) {
            this.nextSchedule.setShowPlayList("");
        }
    }

}
