package com.miaozhen.device.support.christie;

import java.io.IOException;
import java.net.Socket;

import com.miaozhen.device.support.christie.playbackcontrol.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class PlaybackControlChris {
    private String error =
        "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>ERROR</error>\n</response>";
    private final Logger logger = LoggerFactory.getLogger(getClass());
    private Socket socket = null;
    private GetPlaybackStatusTMS cmd = null;

    public void setSocket(Socket socket) {
        this.socket = socket;
    }

    public Socket getSocket() {
        return this.socket;
    }

    public String ejectSPL() {
        String result = this.error;
        try {
            if (socket != null && socket.isConnected()) {
                EjectTMS cmd = new EjectTMS(socket);
                cmd.execute();
                result = cmd.getResponse();
            }
        } catch (IOException e) {
            logger.error("IOException error", e);
        }
        return result;
    }
    public String getplaybackstatus(String ip) {
        String result = this.error;
        try {
            if (socket != null && socket.isConnected()) {
                cmd = new GetPlaybackStatusTMS(socket, ip, 4502);
                cmd.execute();
                result = cmd.getResponse();
            }
        } catch (Exception e) {
            logger.error("IOException {} class {}", e.getMessage(), e.getClass().getName());
            e.printStackTrace();
        }
        return result;
    }
}
