package com.miaozhen.device.support.christie.basecmd;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;

import org.crifst.smi.christie.basecmd.MessageData;
import org.crifst.smi.christie.basecmd.StringElement;

public class LoginTMS extends BaseChristieSeries2SocketCmdTMS {
	private String username;
	private String password;
	private boolean success = false;

	public LoginTMS(Socket socket, String username, String password)
			throws IOException {
		super(socket, (byte) 1);
		this.username = username;
		this.password = password;
	}

	protected byte[] createCmdData() {
		MessageData messageData = new MessageData();
		messageData.addElement(new StringElement(1, this.username));
		messageData.addElement(new StringElement(2, this.password));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		this.success = true;
		return null;
	}

	protected String getErrorMsg(int errorCode) {
		this.success = false;
		return null;
	}

	public boolean isSuccess() {
		return this.success;
	}

	public static void main(String[] args) {
		SocketAddress socketAddress = new InetSocketAddress("218.241.227.150",
				4502);
		Socket socket = new Socket();
		try {
			socket.connect(socketAddress, 10000);
			socket.setSoTimeout(10000);

			LoginTMS login = new LoginTMS(socket, "service", "service");
			login.execute();
			login.getResponse();
			System.out.println(login.isSuccess());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}