package com.miaozhen.device.support.christie.playbackcontrol;

import java.io.IOException;
import java.net.Socket;

import com.miaozhen.device.support.christie.basecmd.BaseNoResultCmdTMS;
import org.crifst.smi.christie.basecmd.MessageData;
import org.crifst.smi.christie.basecmd.StringElement;


/**
 * Created by vance on 16/8/31.
 */
public class AutomationTriggerTMS extends BaseNoResultCmdTMS {

    private String cueLabel;

    public AutomationTriggerTMS(Socket socket, String cueLabel) throws IOException {
        super(socket, (byte)74);
        this.cueLabel = cueLabel;
    }

    @Override
    protected byte[] createCmdData() {
        MessageData messageData = new MessageData();
        messageData.addElement(new StringElement(1, cueLabel));
        return messageData.getElementsData();
    }

    @Override
    protected String getErrorMsg(int errorCode) {
        String errorMsg = "AutomationTrigger Error";
        switch (errorCode) {
            case 1000:
                errorMsg = "Invalid cueLabel : " + cueLabel;
                break;
        }
        return errorMsg;
    }
}
