package com.miaozhen.device.support.christie.playbackcontrol;

import com.miaozhen.device.support.christie.basecmd.BaseParamUUIDNoResultCmdTMS;

import java.io.IOException;
import java.net.Socket;



public class LoadContentTMS extends BaseParamUUIDNoResultCmdTMS {

	public LoadContentTMS(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, (byte)61, UUID.replaceAll("urn:uuid:", "playlist_"));
	}

	public LoadContentTMS(Socket socket, String UUID) throws IOException {
		super(socket, (byte)61, UUID.replaceAll("urn:uuid:", "playlist_"));
	}

	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "ID not found";
			break;
		case 7:
			errorMsg = "Content is currently playing.";
			break;
		case 8:
			errorMsg = "Unable to load content when a performance test is in progress.";
			break;
		case 13:
			errorMsg = "SN Connection Failure";
		}

		return errorMsg;
	}

}
