package com.miaozhen.device.support.christie.playbackcontrol;

import java.io.IOException;
import java.net.Socket;

import com.miaozhen.device.support.christie.basecmd.BaseNoResultCmdTMS;
import org.crifst.smi.christie.basecmd.LongElement;
import org.crifst.smi.christie.basecmd.MessageData;



public class PlayTMS extends BaseNoResultCmdTMS {
	protected long position;

	public PlayTMS(Socket socket,String host, int tcpPort, long position) throws IOException {
		super(socket ,host, tcpPort, (byte)63);
		this.position = position;
	}

	public PlayTMS(Socket socket, long position) throws IOException {
		super(socket, (byte)63);
		this.position = position;
	}

	protected byte[] createCmdData() {
		MessageData messageData = new MessageData();
		messageData.addElement(new LongElement(1, this.position));
		return messageData.getElementsData();
	}

	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "Invalid offset";
			break;
		case 2:
			errorMsg = "Playback error";
			break;
		case 3:
			errorMsg = "Content not loaded";
			break;
		case 4:
			errorMsg = "Already Playing";
			break;
		case 5:
			errorMsg = "Not married";
		}

		return errorMsg;
	}
}
