package com.miaozhen.device.support.christienew;

import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import com.christie.dcinema.xml.statusitem.Status;
import com.miaozhen.device.support.christienew.data.LElement;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.StatusItem;
import com.miaozhen.device.support.christienew.playbackcontrol.GetStatusTMSNew;

public class GetPlaybackStatusTMSNew extends GetStatusTMSNew {

    public static enum SmiPlaybackStateTypeEnum {
        PLAYING, PAUSED, STOPPED, ERROR;

        public String value() {
            return name();
        }

        public static SmiPlaybackStateTypeEnum fromValue(String v) {
            return valueOf(v);
        }
    }

    /*private static Integer[] keys = { Integer.valueOf(751), Integer.valueOf(759), Integer.valueOf(758), Integer.valueOf(753), Integer.valueOf(766),
            Integer.valueOf(762), Integer.valueOf(760) };*/

    public static List<Status> statuslist = new ArrayList<>();
    
    public static String showUUID;

    public static long playPosition;

    public static boolean pause = false;

    public GetPlaybackStatusTMSNew(Socket socket, String host, int tcpPort, Integer[] keys) throws IOException {
    	super(socket, host, tcpPort, keys);
    }

    public GetPlaybackStatusTMSNew(Socket socket, Integer[] keys) throws IOException {
        super(socket, keys);
    }

    
    protected String getResult(byte[] data) {
		//List<Status> statuslist = new ArrayList<>();
		LMessageData messageData = new LMessageData(data);
		LElement element = messageData.getElements().get(0);
		/*for (LElement element : messageData.getElements()) {*/
			LStringElement stringElement = new LStringElement(element);
			String getxml=stringElement.getValue();
			String getxmlfin=getxml.replaceAll("<StatusItems>", "");
			getxmlfin=getxmlfin.replaceAll("</StatusItems>", "");
			getxmlfin=getxmlfin.replaceAll("StatusItem", "status");
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
					+ getxmlfin;
			try {
				statuslist
						.add((Status) new StatusXmlObject(xml).getXmlObject());
				return "success";
			} catch (Exception e) {
				e.printStackTrace();
				return "failed";
			}
		//}
		//return getResult(statuslist);
	}
    
    public String getResult(List<Status> statuslist) {
        String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >";

        String playbackMode = "";
        String state = SmiPlaybackStateTypeEnum.ERROR.name();
        String showId = "";
        String showName = "";
        String showPlayedDuration = "0";
        String showTotalDuration = "0";
        String cplId = "";
        String cplName = "";
        String cplPlayedDuration = "0";
        String cplTotalDuration = "0";
        for (Status status : statuslist)
            switch (status.getId()) {
                case 766:
                    playbackMode = (Boolean.valueOf(status.getValue()).booleanValue()) ? "LOOP" : "NO LOOP";
                    break;
                case 760:
                    switch (Integer.valueOf(status.getValue()).intValue()) {
                        case 0:
                            state = SmiPlaybackStateTypeEnum.STOPPED.name();
                            break;
                        case 1:
                            state = SmiPlaybackStateTypeEnum.PLAYING.name();
                            break;
                        case 2:
                            state = SmiPlaybackStateTypeEnum.PAUSED.name();
                            pause = true;
                            break;
                    }
                    break;
                case 753:
                    showId = status.getValue().replaceAll("playlist_", "urn:uuid:");
                    if(!showId.contains("urn:uuid:")){
                    	showId="urn:uuid:"+showId;
                    }
                    showUUID = showId;
                    break;
                case 759:
                    showPlayedDuration = status.getValue();
                    playPosition = Long.valueOf(showPlayedDuration).longValue();
                    break;
                case 758:
                    showTotalDuration = status.getValue();
                    break;
                case 762:
                    cplId = status.getValue();
                    if(!cplId.contains("urn:uuid:")){
                    	cplId="urn:uuid:"+cplId;
                    }
                    break;
                case 751:
                    cplPlayedDuration = ((status.getValue() == null) || (status.getValue().isEmpty())) ? "0" : status.getValue();
                    break;
            }
        // try {
        // GetPlaybackShowInfo cmd = new GetPlaybackShowInfo(this.socket,
        // showId, cplId);
        // cmd.execute();
        // GetPlaybackShowInfo.ShowInfo showInfo = cmd.getShowInfo();
        // showName = (showInfo.getShowName() == null) ? "" : showInfo
        // .getShowName();
        // cplName = (showInfo.getCplName() == null) ? "" : showInfo
        // .getCplName();
        // cplTotalDuration = (showInfo.getCplDuration() == null) ? "0"
        // : showInfo.getCplDuration();
        // } catch (IOException e) {
        // e.printStackTrace();
        // }
        xml = xml + "\n\t<playbackmode>" + playbackMode + "</playbackmode>";
        xml = xml + "\n\t<status state=\"" + state + "\" >";
        xml = xml + "\n\t\t<show_uuid>" + showId + "</show_uuid>";
        xml = xml + "\n\t\t<show_name>" + showName + "</show_name>";
        xml = xml + "\n\t\t<show_position total_duration=\"" + (Long.valueOf(showTotalDuration).longValue() / 1000L) + "\" played_duration=\""
                + (playPosition / 1000L) + "\" />";
        xml = xml + "\n\t\t<cpl_uuid>" + cplId + "</cpl_uuid>";
        xml = xml + "\n\t\t<cpl_name>" + cplName + "</cpl_name>";
        xml = xml + "\n\t\t<cpl_position cpl_index=\"0\" total_duration=\"" + (Long.valueOf(cplTotalDuration).longValue()) + "\" played_duration=\""
                + (Long.valueOf(cplPlayedDuration).longValue() / 1000L) + "\" />";
        xml = xml + "\n\t</status>\n</response>";
        return xml;
    }

    
    
    protected String getResultItem(List<StatusItem> statuslist) {
        String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >";

        String playbackMode = "";
        String state = SmiPlaybackStateTypeEnum.ERROR.name();
        String showId = "";
        String showName = "";
        String showPlayedDuration = "0";
        String showTotalDuration = "0";
        String cplId = "";
        String cplName = "";
        String cplPlayedDuration = "0";
        String cplTotalDuration = "0";
        for (StatusItem status : statuslist)
            switch (status.getId()) {
                case 766:
                    playbackMode = (Boolean.valueOf(status.getValue()).booleanValue()) ? "LOOP" : "NO LOOP";
                    break;
                case 760:
                    switch (Integer.valueOf(status.getValue()).intValue()) {
                        case 0:
                            state = SmiPlaybackStateTypeEnum.STOPPED.name();
                            break;
                        case 1:
                            state = SmiPlaybackStateTypeEnum.PLAYING.name();
                            break;
                        case 2:
                            state = SmiPlaybackStateTypeEnum.PAUSED.name();
                            pause = true;
                            break;
                    }
                    break;
                case 753:
                    showId = status.getValue().replaceAll("playlist_", "urn:uuid:");
                    showUUID = showId;
                    break;
                case 759:
                    showPlayedDuration = status.getValue();
                    playPosition = Long.valueOf(showPlayedDuration).longValue();
                    break;
                case 758:
                    showTotalDuration = status.getValue();
                    break;
                case 762:
                    cplId = status.getValue();
                    break;
                case 751:
                    cplPlayedDuration = ((status.getValue() == null) || (status.getValue().isEmpty())) ? "0" : status.getValue();
                    break;
            }
        // try {
        // GetPlaybackShowInfo cmd = new GetPlaybackShowInfo(this.socket,
        // showId, cplId);
        // cmd.execute();
        // GetPlaybackShowInfo.ShowInfo showInfo = cmd.getShowInfo();
        // showName = (showInfo.getShowName() == null) ? "" : showInfo
        // .getShowName();
        // cplName = (showInfo.getCplName() == null) ? "" : showInfo
        // .getCplName();
        // cplTotalDuration = (showInfo.getCplDuration() == null) ? "0"
        // : showInfo.getCplDuration();
        // } catch (IOException e) {
        // e.printStackTrace();
        // }
        xml = xml + "\n\t<playbackmode>" + playbackMode + "</playbackmode>";
        xml = xml + "\n\t<status state=\"" + state + "\" >";
        xml = xml + "\n\t\t<show_uuid>" + showId + "</show_uuid>";
        xml = xml + "\n\t\t<show_name>" + showName + "</show_name>";
        xml = xml + "\n\t\t<show_position total_duration=\"" + (Long.valueOf(showTotalDuration).longValue() / 1000L) + "\" played_duration=\""
                + (playPosition / 1000L) + "\" />";
        xml = xml + "\n\t\t<cpl_uuid>" + cplId + "</cpl_uuid>";
        xml = xml + "\n\t\t<cpl_name>" + cplName + "</cpl_name>";
        xml = xml + "\n\t\t<cpl_position cpl_index=\"0\" total_duration=\"" + (Long.valueOf(cplTotalDuration).longValue()) + "\" played_duration=\""
                + (Long.valueOf(cplPlayedDuration).longValue() / 1000L) + "\" />";
        xml = xml + "\n\t</status>\n</response>";
        return xml;
    }
    
    /*public String getShowUUID() {
        return this.showUUID;
    }*/

    /*public long getPlayPosition() {
        return playPosition;
    }*/

    /*public boolean isPause() {
        return this.pause;
    }*/
}
