package com.miaozhen.device.support.christienew.data;

import org.crifst.smi.christie.basecmd.Util;

public class LElement {

	private int key;
	private int length;
	private byte type;
	private byte[] data;

	public LElement(int key, int length,byte type, byte[] data) {
		this.key = key;
		this.length = length;
		this.type=type;
		this.data = data;
	}

	public LElement(byte[] key, byte[] length,byte type, byte[] data) {
		this.key = Util.littleEndianToInt(key);
		this.length = Util.decodeDefiniteFormBER(length);
		this.type=type;
		this.data = data;
	}
	
	
	public byte getType() {
		return type;
	}

	public void setType(byte type) {
		this.type = type;
	}

	public int getKey() {
		return this.key;
	}

	public void setKey(int key) {
		this.key = key;
	}

	public int getLength() {
		return this.length;
	}

	public void setLength(int length) {
		this.length = length;
	}

	public byte[] getData() {
		return this.data;
	}

	public void setData(byte[] data) {
		this.data = data;
	}

	public byte[] getElement() {
		byte[] by=new byte[1];
		by[0]=this.type;
		byte[][] src = { Util.intToLittleEndian(this.key), Util.encodeDefiniteFormBER(this.length+1),by,this.data };
		return Util.byteArrayCopy(src);
	}

}
