package com.miaozhen.device.support.christienew.playbackcontrol;

import com.miaozhen.device.support.christienew.basecmd.BaseNoResultCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;


public class AutomationTriggerTMSNew extends BaseNoResultCmdTMSNew {

    private String cueLabel;

    private static short objid=312;
    public AutomationTriggerTMSNew(Socket socket, String cueLabel) throws IOException {
        super(socket, objid);
        this.cueLabel = cueLabel;
    }

    @Override
    protected byte[] createCmdData() {
        LMessageData messageData = new LMessageData();
        messageData.addElement(new LStringElement(0, "UserRequest"));
        messageData.addElement(new LStringElement(1, cueLabel));
        messageData.addElement(new LStringElement(2, cueLabel));
        return messageData.getElementsData();
    }

    @Override
    protected String getErrorMsg(int errorCode) {
        String errorMsg = "AutomationTrigger Error";
        switch (errorCode) {
            case 2:
                errorMsg = "Invalid cueLabel : " + cueLabel;
                break;
        }
        return errorMsg;
    }
}
