package com.miaozhen.device.support.christienew.playbackcontrol;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDNoResultCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LINT32Element;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;

import java.io.IOException;
import java.net.Socket;
public class LoadContentTMSNew extends BaseParamUUIDNoResultCmdTMSNew {

	private static short objid=61;
	private String UUID;
	public LoadContentTMSNew(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, objid, UUID.replaceAll("urn:uuid:", "playlist_"));
		this.UUID=UUID.replaceAll("urn:uuid:", "playlist_");
	}

	public LoadContentTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, objid, UUID.replaceAll("urn:uuid:", "playlist_"));
		this.UUID=UUID.replaceAll("urn:uuid:", "playlist_");
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LStringElement(1, this.UUID));
		messageData.addElement(new LINT32Element(2, 0));
		return messageData.getElementsData();
	}
	
	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "ID not found";
			break;
		case 7:
			errorMsg = "Content is currently playing.";
			break;
		case 8:
			errorMsg = "Unable to load content when a performance test is in progress.";
			break;
		case 13:
			errorMsg = "SN Connection Failure";
		}

		return errorMsg;
	}

}
