package com.miaozhen.device.support.christienew.playbackcontrol;

import com.miaozhen.device.support.christienew.basecmd.BaseNoResultCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LLongElement;
import com.miaozhen.device.support.christienew.data.LMessageData;

import java.io.IOException;
import java.net.Socket;


public class PlayTMSNew extends BaseNoResultCmdTMSNew {
	protected long position;

	private static short objid=63;
	public PlayTMSNew(Socket socket, String host, int tcpPort, long position) throws IOException {
		super(socket ,host, tcpPort, objid);
		this.position = position;
	}

	public PlayTMSNew(Socket socket, long position) throws IOException {
		super(socket, objid);
		this.position = position;
	}

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LLongElement(1, this.position));
		return messageData.getElementsData();
	}

	protected String getErrorMsg(int errorCode) {
		String errorMsg = "Error";
		switch (errorCode) {
		case 1:
			errorMsg = "Invalid offset";
			break;
		case 2:
			errorMsg = "Playback error";
			break;
		case 3:
			errorMsg = "Content not loaded";
			break;
		case 4:
			errorMsg = "Already Playing";
			break;
		case 5:
			errorMsg = "Not married";
		}

		return errorMsg;
	}
}
