package com.miaozhen.device.support.christienew.systemmanagerment;

import java.io.IOException;
import java.net.Socket;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.miaozhen.device.support.christienew.basecmd.BaseNoParamCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;


public class GetSMTimeTMSNew extends BaseNoParamCmdTMSNew {
	//108
	public GetSMTimeTMSNew(Socket socket, String host, int tcpPort) throws IOException {
		super(socket, host, tcpPort, (short)1112);
	}

	public GetSMTimeTMSNew(Socket socket) throws IOException {
		super(socket, (short)1112);
	}

	protected String getResult(byte[] data) {
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(2));
		String str=element.getValue();
		 SimpleDateFormat myFmt2=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		 Date iso_date_time=new Date();
		try {
			iso_date_time = myFmt2.parse(str);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*Date iso_date_time = new Date(Long.valueOf(element.getValue())
				.longValue());*/
		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n";
		xml = xml
				+ "\t<iso_date_time>"
				+ new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ")
						.format(iso_date_time) + "</iso_date_time>\n";
		xml = xml + "</response>";
		return xml;
	}

	protected String getErrorMsg(int errorCode) {
		return "Can not get server date time.";
	}
}