package com.miaozhen.device.support.dolby;

import java.util.Iterator;
import java.util.List;

import org.apache.commons.httpclient.params.HttpClientParams;
import org.codehaus.xfire.client.Client;
import org.codehaus.xfire.transport.http.CommonsHttpMessageSender;
import org.crifst.project.tms.smi.dolby.api.Util;

import com.dolby.dcinema.ws.smi.v1.LicenseManagementService_v1_0;
import com.dolby.dcinema.ws.smi.v1.LicenseManagement_v1_0Client;
import com.dolby.dcinema.ws.smi.v1_0.GetKDMRequest;
import com.dolby.dcinema.ws.smi.v1_0.GetKDMResponse;
import com.dolby.dcinema.ws.smi.v1_0.GetLicensesRequest;
import com.dolby.dcinema.ws.smi.v1_0.GetLicensesResponse;

public class LicenseManagementDolby {
	
	private LicenseManagement_v1_0Client client;
	private LicenseManagementService_v1_0 service;
	
	private String i;
	
	public LicenseManagementDolby(HttpClientParams params,String ip){
		client = new LicenseManagement_v1_0Client();
		this.i = Util.ip2AuditoriumNumber(ip);
		service = client.getLicenseManagementService_v1_0("http://" + ip
						+ ":8080/dcinema/ws/smi/v1/LicenseManagementService");
		Client.getInstance(service).setProperty(
				CommonsHttpMessageSender.HTTP_CLIENT_PARAMS, params);
	}
	
	public String getkdmlist(String IP) {
		StringBuilder builder = null;
		GetLicensesResponse response = null;
		GetLicensesRequest request = new GetLicensesRequest();
		request.setAuditoriumNumber(i);
		try {
			response = service.getLicenses(request);
			builder = new StringBuilder(
					"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >");
			List<String> uuid_list = response.getLicenseId();
			if (uuid_list == null)
				return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>\"uuid_list is null \"</error>"
						+ "\n</response>";
			for (Iterator<String> it = uuid_list.iterator(); it.hasNext();) {
				builder.append("\n\t<asset_uuid>" + ((String) it.next())
						+ "</asset_uuid>");
			}
			builder.append("\n</response>");
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return builder.toString();
	}
	
	public String getkdm(String IP, String UUID) {
		GetKDMResponse response = null;
		StringBuilder builder = null;
		GetKDMRequest request = new GetKDMRequest();
		request.setLicenseId(UUID);
		try {
			response = service.getKDM(request);
			builder = new StringBuilder(
					"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >");
			builder.append("\n\t<response_text>");
			String kdm = response.getLicense();
			kdm = kdm.replace("&", "&amp;");
			kdm = kdm.replace("\"", "&quot;");
			kdm = kdm.replace("<", "&lt;");
			builder.append(kdm);
			builder.append("</response_text>");
			builder.append("\n</response>");
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}

		return builder.toString();
	}

}