package com.miaozhen.device.support.dolby;

import java.util.Calendar;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.Duration;

import org.apache.commons.httpclient.params.HttpClientParams;
import org.crifst.project.tms.smi.dolby.api.Util;

import com.dolby.dcinema.ws.smi.v1.*;
import com.dolby.dcinema.ws.smi.v1.schemas.common.PlayableContentType;
import com.dolby.dcinema.ws.smi.v1.schemas.common.TransportStateTypeEnum;
import com.dolby.dcinema.ws.smi.v1.schemas.contentmanagement.ClipInfo;
import com.dolby.dcinema.ws.smi.v1.schemas.playbackcontrol.ContentPlaybackState;
import com.dolby.dcinema.ws.smi.v1.schemas.playbackcontrol.PlaybackMode;
import com.dolby.dcinema.ws.smi.v1.schemas.showmanagement.ShowInfo;
import com.dolby.dcinema.ws.smi.v1_0.*;
import com.dolby.dcinema.ws.smi.v1_1.FireCueRequest;

public class PlaybackControlDolby {
	private PlaybackControl_v1_1Client client;
	//private PlaybackControl_v1_0Client client ;
	private PlaybackControlService_v1_1 service;
	
	private String i;
	
	private ShowManagement_v1_1Client c;
	private ShowManagementService_v1_1 s;
	
	private ContentManagement_v1_0Client c2;
	private ContentManagementService_v1_0 s2 ;
	
	public static enum SmiTransportStateTypeEnum {
		QUEUED, RUNNING, FINISHED, ERROR;

		public String value() {
			return name();
		}

		public static SmiTransportStateTypeEnum fromValue(String v) {
			return valueOf(v);
		}
	}

	public enum SmiPlaybackStateTypeEnum {
		PLAYING, PAUSED, STOPPED, ERROR;

		public String value() {
			return name();
		}

		public static SmiPlaybackStateTypeEnum fromValue(String v) {
			return valueOf(v);
		}
	}
	
	public PlaybackControlDolby(HttpClientParams params,String ip){
		this.i = Util.ip2AuditoriumNumber(ip);
		this.client = new PlaybackControl_v1_1Client();
		this.service = client
					.getPlaybackControlService_v1_0("http://" + ip
							+ ":8080/dcinema/ws/smi/v1/PlaybackControlService");
//		Client.getInstance(service).setProperty(
//				CommonsHttpMessageSender.HTTP_CLIENT_PARAMS, params);
		c = new ShowManagement_v1_1Client();
		s = c.getShowManagementService_v1_0("http://" + ip
				+ ":8080/dcinema/ws/smi/v1/ShowManagementService");
//		Client.getInstance(s).setProperty(
//				CommonsHttpMessageSender.HTTP_CLIENT_PARAMS, params);
		c2 = new ContentManagement_v1_0Client();
		s2 = c2.getContentManagementService_v1_0("http://" + ip
				+ ":8080/dcinema/ws/smi/v1/ContentManagementService");
//		Client.getInstance(s2).setProperty(
//				CommonsHttpMessageSender.HTTP_CLIENT_PARAMS, params);
	}
	
	public  String getplaybackstatus(String IP) {
		StringBuilder builder = null;
		GetPlaybackStateResponse response = null;
		GetPlaybackStateRequest request = new GetPlaybackStateRequest();
		try {
			response = service.getPlaybackState(request);
			TransportStateTypeEnum ts = response.getTransportState()
					.getTransportStateType().getValue();
			ContentPlaybackState cps = response.getContentPlaybackState();
			PlaybackMode pm = response.getPlaybackMode();
			builder = new StringBuilder(
					"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n\t<playbackmode>"
							+ pm.name() + "</playbackmode>");

			String ERROR = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<playbackmode>"
					+ pm.name() + "</playbackmode>" + "\n</response>";
			String STOPPED1 = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n\t<playbackmode>"
					+ pm.name()
					+ "</playbackmode>"
					+ "\n\t<status state=\""
					+ SmiPlaybackStateTypeEnum.STOPPED.name()
					+ "\" >"
					+ "\n\t\t<show_uuid>urn:uuid:00000000-0000-0000-0000-000000000000</show_uuid>"
					+ "\n\t\t<show_name></show_name>"
					+ "\n\t\t<show_position total_duration=\"0\" played_duration=\"0\" />"
					+ "\n\t\t<cpl_name></cpl_name>"
					+ "\n\t\t<cpl_uuid>urn:uuid:00000000-0000-0000-0000-000000000000</cpl_uuid>"
					+ "\n\t\t<cpl_position total_duration=\"0\" cpl_index=\"0\" played_duration=\"0\" />"
					+ "\n\t</status>" + "\n</response>";
			// logger.info("status={} ip ={}",ts,IP);
			switch (ts) {
			case READY:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.STOPPED.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case SELECTING:
				return STOPPED1;
			case RECOVERING:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.STOPPED.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case LATE:
				return STOPPED1;
			case PLAYING:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.PLAYING.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case STOPPED:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.STOPPED.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case PAUSED:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.PAUSED.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case UNSELECTED:
				return STOPPED1;
			case SEEKING:
				builder.append("\n\t<status state=\""
						+ SmiPlaybackStateTypeEnum.STOPPED.name() + "\" >");
				buildstatus(IP, builder, i, cps);
				builder.append("\n\t</status>");
				break;
			case UNAVAILABLE:
				return STOPPED1;
			case EXTENSION:
				return ERROR;
			default:
				return ERROR;
			}

			builder.append("\n</response>");
		} catch (Exception e) {
			e.printStackTrace();
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}

		return builder.toString();
	}

	private void buildstatus(String IP, StringBuilder builder, String i,
			ContentPlaybackState cps){
		int cplindex = 0;
		Calendar calendar = Calendar.getInstance();
		String showuuid = cps.getContentId();
		String clipuuid = cps.getCurrentClipId();
		if (showuuid == null) {
			builder.append("\n\t\t<show_uuid>urn:uuid:00000000-0000-0000-0000-000000000000</show_uuid>");
			builder.append("\n\t\t<show_name></show_name>");
			builder.append("\n\t\t<show_position total_duration=\"0\" played_duration=\"0\" />");
		} else if (!showuuid.equals(clipuuid)) {
			builder.append("\n\t\t<show_uuid>" + showuuid + "</show_uuid>");
			GetShowInfosResponse rp1 = null;
			GetShowInfosRequest r1 = new GetShowInfosRequest();
			r1.setShowId(cps.getContentId());
			r1.setAuditoriumNumber(i);
			String showname = "";
			try {
				rp1 = s.getShowInfos(r1);
				showname = ((ShowInfo) rp1.getShowInfo().get(0)).getName();
			} catch (Fault fault) {
				fault.printStackTrace();
			}

			builder.append("\n\t\t<show_name>" + showname + "</show_name>");
			builder.append("\n\t\t<show_position total_duration=\""
					+ (int) Math.floor(cps.getShowDuration().getTimeInMillis(
							calendar) / 1000L)
					+ "\" "
					+ "played_duration=\""
					+ (int) Math.floor(cps.getShowPosition().getTimeInMillis(
							calendar) / 1000L) + "\" />");
			cplindex = cps.getCurrentClipIndex().intValue();
		}

		builder.append("\n\t\t<cpl_uuid>" + cps.getCurrentClipId()
				+ "</cpl_uuid>");
		GetClipInfosResponse rp2 = null;
		GetClipInfosRequest r2 = new GetClipInfosRequest();
		r2.setClipId(cps.getCurrentClipId());
		r2.setAuditoriumNumber(i);
		String clipname = "";
		try {
			rp2 = s2.getClipInfos(r2);
			clipname = ((ClipInfo) rp2.getClipInfo().get(0)).getName();
		} catch (Fault fault) {
			fault.printStackTrace();
		}

		builder.append("\n\t\t<cpl_name>" + clipname + "</cpl_name>");
		builder.append("\n\t\t<cpl_position total_duration=\""
				+ (int) Math.floor(cps.getClipDuration().getTimeInMillis(
						calendar) / 1000L)
				+ "\" "
				+ "cpl_index=\""
				+ cplindex
				+ "\" "
				+ "played_duration=\""
				+ (int) Math.floor(cps.getClipPosition().getTimeInMillis(
						calendar) / 1000L) + "\" />");

		if (clipuuid.equals(showuuid)) {
			builder.append("\n\t\t<show_uuid>" + showuuid + "</show_uuid>");
			builder.append("\n\t\t<show_name>" + clipname + "</show_name>");
			builder.append("\n\t\t<show_position total_duration=\""
					+ (int) Math.floor(cps.getClipDuration().getTimeInMillis(
							calendar) / 1000L)
					+ "\" "
					+ "played_duration=\""
					+ (int) Math.floor(cps.getClipPosition().getTimeInMillis(
							calendar) / 1000L) + "\" />");
		}
	}


	public String stopspl(String IP) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		StopRequest request = new StopRequest();
		try {
		  service.stop(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String playspl(String IP) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		PlayRequest request = new PlayRequest();
		try {
			service.play(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String pausespl(String IP) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		PauseRequest request = new PauseRequest();
		try {
			service.pause(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String unpausespl(String IP) {
		return playspl(IP);
	}

	public String selectspl(String IP, String UUID) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		SelectContentRequest request = new SelectContentRequest();
		request.setContentId(UUID);
		request.setPlayableContentType(PlayableContentType.SHOW);
		try {
			service.selectContent(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String goToPosition(String IP, int intDuration)
			throws DatatypeConfigurationException {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		GoToPositionRequest request = new GoToPositionRequest();
		Duration value = DatatypeFactory.newInstance().newDuration(
				intDuration * 1000);
		request.setPosition(value);
		try {
			 service.goToPosition(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String next(String IP) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		NextRequest request = new NextRequest();
		try {
			service.next(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String previous(String IP) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		PreviousRequest request = new PreviousRequest();
		try {
			service.previous(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}

	public String fireCue(String cueLabel) {
		String isok = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n</response>";
		FireCueRequest request = new FireCueRequest();
		request.setCueId(cueLabel);
		try {
			service.fireCue(request);
		} catch (Exception e) {
			return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"ERROR\" version=\"2\" >\n\t<error>"
					+ e.getMessage() + "</error>" + "\n</response>";
		}
		return isok;
	}
}
