package com.miaozhen.task;

import com.miaozhen.task.domain.ScheduleJob;
import org.quartz.Job;
import org.quartz.JobDataMap;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;


/**
 * 定时任务工厂类
 * 
 * @version
 */
public class QuartzJobFactory implements Job, ApplicationEventPublisherAware {

	public static final String SCHEDULEJOB_KEY = "scheduleJob";

	@Override
	public void execute(JobExecutionContext paramJobExecutionContext) throws JobExecutionException {
		JobDataMap jobDataMap = paramJobExecutionContext.getMergedJobDataMap();
		ScheduleJob scheduleJob = (ScheduleJob) jobDataMap.get(SCHEDULEJOB_KEY);
		scheduleJob.getJob().execute();
	}

	@Override
	public void setApplicationEventPublisher(ApplicationEventPublisher paramApplicationEventPublisher) {

	}

}
