package com.miaozhen.task.domain;

import com.miaozhen.task.JobInterface;
import org.quartz.DateBuilder;

public class ScheduleJob {

	//获取日志及上报
	public static final String SERVERLOG_JOB_ID = "NO1_";

	public static final String SERVERLOG_JOB_NAME = "SERVERLOG_";

	public static final String SERVERLOG_JOB_GROUP = "SERVERLOG";

	public static final int SERVERLOG_JOB_DEFAULT_BEGIN = 5;// 开始执行时间：5分钟

	public static final int SERVERLOG_JOB_DEFAULT_INTERVAL = 180;// 秒(间隔执行时间3分钟)

   //获取tms相关配置信息
	public static final String GETCINEMAINFO_JOB_ID = "NO2_";

	public static final String GETCINEMAINFO_JOB_NAME = "GETCINEMAINFO_";

	public static final String GETCINEMAINFO_JOB_GROUP = "GETCINEMAINFO";

	public static final int GETCINEMAINFO_JOB_DEFAULT_BEGIN = 3;// 开始执行时间：3分钟

	public static final int GETCINEMAINFO_JOB_DEFAULT_INTERVAL = 600;// 秒(间隔执行时间10分钟)

   //日志定时清理
	public static final String CLEARLOG_JOB_ID = "NO3_";

	public static final String CLEARLOG_JOB_NAME = "CLEARLOG_";

	public static final String CLEARLOG_JOB_GROUP = "CLEARLOG";

	public static final int CLEARLOG_JOB_DEFAULT_BEGIN = 10;// 开始执行时间：10分钟

	public static final int CLEARLOG_JOB_DEFAULT_INTERVAL = 18000;// 秒(间隔执行时间5小时)



	private JobInterface job;

	/** 任务id */
	private String jobId;

	/** 任务名称 */
	private String jobName;

	/** 任务分组 */
	private String jobGroup;

	/** 任务状态 0禁用 1启用 2删除 */
	private String jobStatus;

	/** 任务运行时间表达式 */
	private String cronExpression;

	/** 任务描述 */
	private String desc;

	private Integer number;

	/** 开始时间 */
	private int beginTime;

	/**
	 * 时间间隔单位 ，自己选择设置单位：{ MILLISECOND, SECOND, MINUTE, HOUR, DAY, WEEK, MONTH,
	 * YEAR } 设置后：开始执行时间的单位和这个保持一致
	 */
	private DateBuilder.IntervalUnit intervalUnit;
	/** 间隔执行时间 ：统一单位为秒 */
	private int intervalTime;

	public String getJobId() {
		return jobId;
	}

	public void setJobId(String jobId) {
		this.jobId = jobId;
	}

	public String getJobName() {
		return jobName;
	}

	public void setJobName(String jobName) {
		this.jobName = jobName;
	}

	public String getJobGroup() {
		return jobGroup;
	}

	public void setJobGroup(String jobGroup) {
		this.jobGroup = jobGroup;
	}

	public String getJobStatus() {
		return jobStatus;
	}

	public void setJobStatus(String jobStatus) {
		this.jobStatus = jobStatus;
	}

	public String getCronExpression() {
		return cronExpression;
	}

	public void setCronExpression(String cronExpression) {
		this.cronExpression = cronExpression;
	}

	public String getDesc() {
		return desc;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}

	public Integer getNumber() {
		return number;
	}

	public void setNumber(Integer number) {
		this.number = number;
	}

	public JobInterface getJob() {
		return job;
	}

	public void setJob(JobInterface job) {
		this.job = job;
	}

	public int getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(int beginTime) {
		this.beginTime = beginTime;
	}

	public int getIntervalTime() {
		return intervalTime;
	}

	public void setIntervalTime(int intervalTime) {
		this.intervalTime = intervalTime;
	}

	public DateBuilder.IntervalUnit getIntervalUnit() {
		return intervalUnit;
	}

	public void setIntervalUnit(DateBuilder.IntervalUnit intervalUnit) {
		this.intervalUnit = intervalUnit;
	}
}
