package com.miaozhen.tmssys;

import com.miaozhen.tmssys.dto.AuditPlaybackStatusResponse;
import com.miaozhen.tmssys.dto.CinemaInfoRestResponse;
import com.miaozhen.util.HttpUtils;
import com.miaozhen.util.JsonMapper;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * 与tms信息相关接口
 */
@Component
public class TmsService {

    Logger logger = LoggerFactory.getLogger(getClass());

    public static final String apiBaseUrl = "http://127.0.0.1:8080/SmartTMS_S3";


    /**
     * 获取影院相关信息
     *
     * @return
     */
    public CinemaInfoRestResponse cinemaInfo() {
        String res = HttpUtils.postData(apiBaseUrl + "/FetchLogController/getCinemaInfo.do", 30);
        if (StringUtils.isEmpty(res)) {
            return null;
        }
        CinemaInfoRestResponse result = JsonMapper.getInstance().fromJson(res, CinemaInfoRestResponse.class);
        return result;
    }

    /**
     * 获取放映服务器播放状态
     *
     * @return
     */
    public AuditPlaybackStatusResponse auditPlaybackStatus() {
        String res = HttpUtils.postData(apiBaseUrl + "/FetchLogController/getAllAuditPlaybackStatus.do", 30);
        if (StringUtils.isEmpty(res)) {
            return null;
        }
        AuditPlaybackStatusResponse result = JsonMapper.getInstance().fromJson(res, AuditPlaybackStatusResponse.class);
        return result;
    }

}
