package com.miaozhen.device.support.christie.basecmd;

import java.io.IOException;
import java.net.Socket;

import javax.xml.bind.JAXBException;

import org.crifst.smi.christie.basecmd.IntegerElement;
import org.crifst.smi.christie.basecmd.MessageData;
import org.crifst.smi.christie.basecmd.StringElement;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import com.christie.dcinema.xml.listcontent.Content;

public abstract class ListContentTMS extends BaseChristieSeries2SocketCmdTMS {
	private int type;

	public ListContentTMS(Socket socket, String host, int tcpPort, int type) throws IOException {
		super(socket, host, tcpPort, (byte)41);
		this.type = type;
	}

	public ListContentTMS(Socket socket, int type) throws IOException {
		super(socket, (byte)41);
		this.type = type;
	}

	protected abstract String getResult(Content paramContent);

	protected byte[] createCmdData() {
		MessageData messageData = new MessageData();
		messageData.addElement(new IntegerElement(1, this.type));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		String result = null;
		MessageData messageData = new MessageData(data);
		StringElement element = new StringElement(
				messageData.getElementByKey(5));
		String xml = element.getValue();
		try {
			result = getResult((Content) new ListContentXmlObject(xml)
					.getXmlObject());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Can not get content list.";
		switch (errorCode) {
		case 1:
			result = "Invalid Type specifed";
			break;
		case 2:
			result = "No Content Drive";
		}
		return result;
	}
	class ListContentXmlObject extends AbstractXmlObject<Content> {
		public ListContentXmlObject(String paramString) throws JAXBException,
				IOException {
			super(paramString);
		}
	}
}