package com.miaozhen.device.support.christie.playbackcontrol;

import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBException;

import com.miaozhen.device.support.christie.basecmd.BaseChristieSeries2SocketCmdTMS;
import org.crifst.smi.christie.basecmd.Element;
import org.crifst.smi.christie.basecmd.IntegerElement;
import org.crifst.smi.christie.basecmd.MessageData;
import org.crifst.smi.christie.basecmd.StringElement;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import com.christie.dcinema.xml.statusitem.Status;

public abstract class GetStatusTMS extends BaseChristieSeries2SocketCmdTMS {
	private Integer[] keys;

	public GetStatusTMS(Socket socket, String host, int tcpPort, Integer[] keys)
			throws IOException {
		super(socket, host, tcpPort, (byte) 21);
		this.keys = keys;
	}

	public GetStatusTMS(Socket socket, Integer[] keys) throws IOException {
		super(socket, (byte) 21);
		this.keys = keys;
	}

	protected abstract String getResult(List<Status> paramList);

	protected byte[] createCmdData() {
//		if (this.elementData != null) {
//			return this.elementData;
//		}
		MessageData messageData = new MessageData();
		for (Integer key : this.keys) {
			messageData.addElement(new IntegerElement(key.intValue(), key
					.intValue()));
		}
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		List<Status> statuslist = new ArrayList<>();
		MessageData messageData = new MessageData(data);
		for (Element element : messageData.getElements()) {
			StringElement stringElement = new StringElement(element);
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
					+ stringElement.getValue();
			try {
				statuslist
						.add((Status) new StatusXmlObject(xml).getXmlObject());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		return getResult(statuslist);
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Error.";
		switch (errorCode) {
		case 1:
			result = "Invalid ID";
			break;
		case 2:
			result = "Invalid Category";
		}
		return result;
	}

	class StatusXmlObject extends AbstractXmlObject<Status> {
		public StatusXmlObject(String paramString) throws JAXBException,
				IOException {
			super(paramString);
		}
	}
}