package com.miaozhen.device.support.christie.playbackcontrol;

import java.io.IOException;
import java.net.Socket;
import java.util.List;

import org.crifst.smi.christie.contentmanagement.CplInfo;
import org.crifst.smi.christie.playbackcontrol.GetPlaybackStatus;
import org.crifst.smi.christie.playbackcontrol.Stop;
import org.crifst.smi.christie.showmanagement.GetPlaylist;

public abstract class SkipTMS extends PlayTMS {
	public SkipTMS(Socket socket, String host, int tcpPort) throws IOException {
		super(socket , host, tcpPort, 0L);
		getPlayIndex();

		Stop cmdStop = new Stop(this.socket);
		cmdStop.execute();
	}

	public SkipTMS(Socket socket) throws IOException {
		super(socket, 0L);
		getPlayIndex();

		Stop cmdStop = new Stop(socket);
		cmdStop.execute();
	}

	protected abstract long setPosition(int paramInt1, int paramInt2,
			long paramLong1, long paramLong2) throws IOException;

	private void getPlayIndex() throws IOException {
		GetPlaybackStatus cmdPlaybackStatus = new GetPlaybackStatus(this.socket);
		cmdPlaybackStatus.execute();
		long playPosition = cmdPlaybackStatus.getPlayPosition();
		String showUUID = cmdPlaybackStatus.getShowUUID();
		GetPlaylist cmdGetPlaylist = new GetPlaylist(this.socket, showUUID);
		cmdGetPlaylist.execute();
		List<CplInfo> cplList = cmdGetPlaylist.getCplList();
		long duration = 0L;
		for (int i = 0; i < cplList.size(); ++i) {
			duration += ((CplInfo) cplList.get(i)).getDuration();
			if (playPosition < duration) {
				long previousDuration = (i == 0) ? 0L : duration
						- ((CplInfo) cplList.get(i)).getDuration()
						- ((CplInfo) cplList.get(i - 1)).getDuration();
				long nextDuration = duration;
				this.position = setPosition(i + 1, cplList.size(),
						previousDuration, nextDuration);
				return;
			}
		}
	}
}
