package com.miaozhen.device.support.christienew.basecmd;

import java.io.IOException;
import java.net.Socket;

import javax.xml.bind.JAXBException;

import com.miaozhen.device.support.christienew.data.LIntegerElement;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import com.christie.dcinema.xml.listcontent.Content;

public abstract class ListContentTMSNew extends BaseChristieSeries2SocketCmdTMSNew {
	private int type;
	private static short objid=41;
	public ListContentTMSNew(Socket socket, String host, int tcpPort, int type) throws IOException {
		super(socket, host, tcpPort, objid);
		this.type = type;
	}

	public ListContentTMSNew(Socket socket, int type) throws IOException {
		super(socket, objid);
		this.type = type;
	}

	protected abstract String getResult(Content paramContent);

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		messageData.addElement(new LIntegerElement(1, this.type));
		return messageData.getElementsData();
	}

	protected String getResult(byte[] data) {
		String result = null;
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(5));
		String xml = element.getValue();
		xml=xml.replaceAll("<isComplete>1</isComplete>","<isComplete>true</isComplete>");
		
		xml=xml.replaceAll("<isEncrypted>1</isEncrypted>","<isEncrypted>true</isEncrypted>");
		
		xml=xml.replaceAll("<hasValidHash>1</hasValidHash>","<hasValidHash>true</hasValidHash>");
		
		xml=xml.replaceAll("<isKeyAvaliable>1</isKeyAvaliable>","<isKeyAvaliable>true</isKeyAvaliable>");
		
		xml=xml.replaceAll("<ValidFromLocalTime>","<ValidFrom>");
		xml=xml.replaceAll("</ValidFromLocalTime>","</ValidFrom>");
		
		xml=xml.replaceAll("<ValidToLocalTime>","<ValidTo>");
		xml=xml.replaceAll("</ValidToLocalTime>","</ValidTo>");
		try {
			result = getResult((Content) new ListContentXmlObject(xml)
					.getXmlObject());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	protected String getErrorMsg(int errorCode) {
		String result = "Can not get content list.";
		switch (errorCode) {
		case 1:
			result = "Invalid Type specifed";
			break;
		case 2:
			result = "No Content Drive";
		}
		return result;
	}
	class ListContentXmlObject extends AbstractXmlObject<Content> {
		public ListContentXmlObject(String paramString) throws JAXBException,
				IOException {
			super(paramString);
		}
	}
}