package com.miaozhen.device.support.christienew.playbackcontrol;

import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBException;

import com.miaozhen.device.support.christienew.basecmd.BaseChristieSeries2SocketCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LElement;
import com.miaozhen.device.support.christienew.data.LIntegerElement;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import com.miaozhen.device.support.christienew.data.xmljaxb.StatusItem;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import com.christie.dcinema.xml.statusitem.Status;

public abstract class GetStatusTMSNew extends BaseChristieSeries2SocketCmdTMSNew {
	private Integer[] keys;

	private static short objid=2012;
	public GetStatusTMSNew(Socket socket, String host, int tcpPort, Integer[] keys)
			throws IOException {
		super(socket, host, tcpPort,objid);
		this.keys = keys;
	}

	public GetStatusTMSNew(Socket socket, Integer[] keys) throws IOException {
		super(socket, objid);
		this.keys = keys;
	}

	protected abstract String getResult(List<Status> paramList);
	protected abstract String getResultItem(List<StatusItem> paramListitem);

	protected byte[] createCmdData() {
		LMessageData messageData = new LMessageData();
		if(keys.length>0){
			Integer key=keys[0];
			messageData.addElement(new LIntegerElement(0, key
					.intValue()));
		}
		return messageData.getElementsData();
	}
	protected String getResult(byte[] data) {
		List<Status> statuslist = new ArrayList<>();
		LMessageData messageData = new LMessageData(data);
		for (LElement element : messageData.getElements()) {
			LStringElement stringElement = new LStringElement(element);
			String getxml=stringElement.getValue();
			String getxmlfin=getxml.replaceAll("<StatusItems>", "");
			getxmlfin=getxmlfin.replaceAll("</StatusItems>", "");
			getxmlfin=getxmlfin.replaceAll("StatusItem", "status");
			String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
					+ getxmlfin;
			try {
				statuslist
						.add((Status) new StatusXmlObject(xml).getXmlObject());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return getResult(statuslist);
	}
	
	protected String getErrorMsg(int errorCode) {
		String result = "Error.";
		switch (errorCode) {
		case 1:
			result = "Invalid ID";
			break;
		case 2:
			result = "Invalid Category";
		}
		return result;
	}
	public class StatusXmlObject extends AbstractXmlObject<Status> {
		public StatusXmlObject(String paramString) throws JAXBException,
				IOException {
			super(paramString);
		}
	}
	
}