package com.miaozhen.device.support.christienew.playbackcontrol;

import java.io.IOException;
import java.net.Socket;
import java.util.List;

import com.miaozhen.device.support.christienew.GetPlaybackStatusTMSNew;
import com.miaozhen.device.support.christienew.systemmanagerment.GetPlaylistTMSNew;
import org.crifst.smi.christie.contentmanagement.CplInfo;

import com.christie.dcinema.xml.statusitem.Status;

public abstract class SkipTMSNew extends PlayTMSNew {
	public SkipTMSNew(Socket socket, String host, int tcpPort) throws IOException {
		super(socket , host, tcpPort, 0L);
		getPlayIndex();

		StopNew cmdStop = new StopNew(this.socket);
		cmdStop.execute();
	}

	public SkipTMSNew(Socket socket) throws IOException {
		super(socket, 0L);
		getPlayIndex();

		StopNew cmdStop = new StopNew(socket);
		cmdStop.execute();
	}

	protected abstract long setPosition(int paramInt1, int paramInt2,
			long paramLong1, long paramLong2) throws IOException;

	private void getPlayIndex() throws IOException {
		
		String rs="";
	    Integer[] keys = { Integer.valueOf(751), Integer.valueOf(759), Integer.valueOf(758), Integer.valueOf(753), Integer.valueOf(766),
	                Integer.valueOf(762), Integer.valueOf(760) };
	    GetPlaybackStatusTMSNew cmdStatus =null;
	    long playPosition=0L;
	    String showUUID="";
	    synchronized(GetPlaybackStatusTMSNew.statuslist){
	    	for(Integer key : keys){
	    		Integer[] k=new Integer[1];
	    		k[0]=key;
	    		cmdStatus  = new GetPlaybackStatusTMSNew(this.socket,k);
	    		cmdStatus.execute();
	    	}
	        rs = cmdStatus.getResponse();
	        if(rs.equals("success")){
	        	List<Status> statuslist=GetPlaybackStatusTMSNew.statuslist;
	        	rs=cmdStatus.getResult(statuslist);
	        }
	        GetPlaybackStatusTMSNew.statuslist.clear();
	        playPosition =GetPlaybackStatusTMSNew.playPosition;
	        showUUID =GetPlaybackStatusTMSNew.showUUID;
	    }
	    
	    
	    
		/*GetPlaybackStatusTMSNew cmdPlaybackStatus = new GetPlaybackStatusTMSNew(this.socket);
		cmdPlaybackStatus.execute();*/
        //long playPosition =GetPlaybackStatusTMSNew.playPosition;
		//long playPosition = cmdPlaybackStatus.getPlayPosition();
        //String showUUID =GetPlaybackStatusTMSNew.showUUID;
        //String showUUID = cmdPlaybackStatus.getShowUUID();
		GetPlaylistTMSNew cmdGetPlaylist = new GetPlaylistTMSNew(this.socket, showUUID);
		cmdGetPlaylist.execute();
		List<CplInfo> cplList = cmdGetPlaylist.getCplList();
		long duration = 0L;
		for (int i = 0; i < cplList.size(); ++i) {
			duration += ((CplInfo) cplList.get(i)).getDuration();
			if (playPosition < duration) {
				long previousDuration = (i == 0) ? 0L : duration
						- ((CplInfo) cplList.get(i)).getDuration()
						- ((CplInfo) cplList.get(i - 1)).getDuration();
				long nextDuration = duration;
				this.position = setPosition(i + 1, cplList.size(),
						previousDuration, nextDuration);
				return;
			}
		}
	}
}
