package com.miaozhen.device.support.christienew.systemmanagerment;

import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBException;

import com.miaozhen.device.support.christienew.basecmd.BaseParamUUIDCmdTMSNew;
import com.miaozhen.device.support.christienew.data.LMessageData;
import com.miaozhen.device.support.christienew.data.LStringElement;
import org.crifst.smi.christie.contentmanagement.CplInfo;
import org.crifst.smi.christie.contentmanagement.GetCplInfo;
import org.crifst.smi.christie.xml.AbstractXmlObject;

import com.christie.dcinema.xml.spl.CDSPlaylist;
import com.christie.dcinema.xml.spl.Entry;

public class GetPlaylistTMSNew extends BaseParamUUIDCmdTMSNew {
	private List<CplInfo> cplList = new ArrayList<>();
	private static short objid=43;
	public GetPlaylistTMSNew(Socket socket, String host, int tcpPort, String UUID)
			throws IOException {
		super(socket, host, tcpPort, objid, UUID.replaceAll("urn:uuid:", "playlist_"));
	}

	public GetPlaylistTMSNew(Socket socket, String UUID) throws IOException {
		super(socket, objid, UUID.replaceAll("urn:uuid:", "playlist_"));
	}

	protected String getResult(byte[] data) {
		LMessageData messageData = new LMessageData(data);
		LStringElement element = new LStringElement(
				messageData.getElementByKey(0));

		String spl = element.getValue();

		try {
		      for (Entry entry : ((CDSPlaylist)new SplXmlObject(spl).getXmlObject()).getEntryList().getEntry()) {
                    String cplId = entry.getCompositionId();
                    GetCplInfo cmd = new GetCplInfo(this.socket, cplId);
                    cmd.execute();
                    this.cplList.add(cmd.getCplInfo());
		      }
		    } catch (JAXBException e) {
		      e.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }
		spl = spl.replace("&", "&amp;");
		spl = spl.replace("\"", "&quot;");
		spl = spl.replace("<", "&lt;");
		spl = spl.replace(">", "&gt;");

		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<response status=\"OK\" version=\"2\" >\n";
		xml = xml + "\t<response_text>" + spl + "</response_text>\n";
		xml = xml + "</response>";
		return xml;
	}

	protected String getErrorMsg(int errorCode) {
		if (errorCode == 1) {
			return "Playlist Not found";
		}
		return "Can not get spl.";
	}

	public List<CplInfo> getCplList() {
		return this.cplList;
	}

	class SplXmlObject extends AbstractXmlObject<CDSPlaylist> {
		public SplXmlObject(String paramString) throws JAXBException,
				IOException {
			super(paramString);
		}
	}
}